/*	
 *	clipmisc.h
 *
 *	顼¾Ǥ
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#ifndef __CLIP_MISC_H__
#define __CLIP_MISC_H__

/*****************************************************************************
 *	ѥޥ
 *****************************************************************************/

#define DIE()		die(__FILE__ "(%d)", __LINE__)

/* ӥå */
#define BTST(a, b)	(((char*)(a))[(b) / 8] &    1 << ((b) & 7) )
#define BCLR(a, b)	(((char*)(a))[(b) / 8] &= ~(1 << ((b) & 7)))
#define BSET(a, b)	(((char*)(a))[(b) / 8] |=   1 << ((b) & 7) )
#define BNOT(a, b)	(((char*)(a))[(b) / 8] ^=   1 << ((b) & 7) )

/* 8ӥå */
#define RAND(s)		(((s) = (s) * 5 + 0x3711) >> 8 & 0xFF)

/*****************************************************************************
 *	顼
 *****************************************************************************/

/* 顼åɽץλޤ
 * [in]
 *	fmt,...		printf()ΰƱͤǤ
 * [note]
 *	* δؿϽ֤ޤ
 */
void die(const char* fmt, ...);

#ifdef PIECE
/*****************************************************************************
 *	P/ECEѡmainե졼
 *****************************************************************************/

/* ץꥱΥȥݥȤǤ
 * [out]
 *			λɡ
 * [note]
 *	* ץꥱλˤϡ̤ˡޤ
 *	  1. main()֤
 *	  2. pceAppReqExit()Ƥ塢yield()Ƥ֡
 */
int main();

/* ƥޤ
 * [note]
 *	* ץꥱϡŪyield()ƤФʤФޤ
 */
void yield();

/* ץཪλ˼¹Ԥؿꤷޤ
 * [in]
 *	func		ؿؤΥݥ
 * [out]
 *			ϿǤ0֤ޤ
 *			Ԥ0ʳ֤ͤޤ
 * [note]
 *	* ߤμǤϡϿǤؿϰĤǤ
 *	  ʤatexit()ʣƤ֤ȡܰʹߤϼԤޤ
 */
int atexit(void (*func )());

/*****************************************************************************
 *	®pceLCDDrawObject
 *****************************************************************************/

/* ®pceLCDDrawObject򥤥󥹥ȡ롦󥤥󥹥ȡ뤷ޤ
 * [note]
 *	* ®pceLCDDrawObjectˤϡΤ褦¤ޤ
 *	- žˡDRW_NOMALġžӥåȥޥåפ2bitǡmaskդǤʳϡ
 *	  ʪpceLCDDrawObject˽ǤޤƤӽФʬ٤ʤޤ
 *	- žˡžӥåȥޥåפϤ߽Фΰꤹȡưޤ
 *	- žӥåȥޥåפϡ8ԥñ̤ΥǺƤʤФޤ
 *	  ¤ϡP/ECEӥåȥޥå׷¤Ǥ⤢ΤǡäդɬפϤޤ
 *	* ץꥱư˰٤hook_LCDDrawObject()Ƥӡ
 *	  ץꥱλˤɬunhook_LCDDrawObject()ɤǤ
 */
void hook_LCDDrawObject();
void unhook_LCDDrawObject();

#endif /*PIECE*/

#endif /*__CLIP_MISC_H__*/
